package sun.security.action;

import java.security.AccessController;
import java.security.PrivilegedAction;

public class GetPropertyAction implements PrivilegedAction<String>
{
    private String theProp;
    private String defaultVal;
    
    public GetPropertyAction(String theProp) {
        this.theProp = theProp;
    }
    
    public GetPropertyAction(String theProp, String defaultVal) {
        this.theProp = theProp;
        this.defaultVal = defaultVal;
    }
    
    @Override
    public String run() {
        String property = System.getProperty(this.theProp);
        return (property == null) ? this.defaultVal : property;
    }
    
    public static String privilegedGetProperty(String key) {
        if (System.getSecurityManager() == null) {
            return System.getProperty(key);
        }
        return (String)AccessController.doPrivileged(new GetPropertyAction(key));
    }
    
    public static String privilegedGetProperty(String key, String def) {
        if (System.getSecurityManager() == null) {
            return System.getProperty(key, def);
        }
        return (String)AccessController.doPrivileged(new GetPropertyAction(key, def));
    }
}
